// name of the file is the name of the module
// Coz when we use a separate file, Rust interprets name of file as name of module by default
const EARTH_RADIUS_IN_KM: f64 = 6371.0;
pub fn distance(start_lat: f64, start_lon: f64, end_lat: f64, end_lon: f64) -> f64 {
    let kcle_lat_rad = start_lat.to_radians();
    let kslc_lat_rad = end_lat.to_radians();

    let delta_lat = (start_lat - end_lat).to_radians();
    let delta_lon = (start_lon - end_lon).to_radians();

    let inner_circle_angle = f64::powi((delta_lat/2.0).sin(), 2)
        + kcle_lat_rad.cos()
        * kslc_lat_rad.cos()
        * f64::powi(delta_lon/2.0, 2);
    let central_angle = 2.0 * inner_circle_angle.sqrt().asin();

    EARTH_RADIUS_IN_KM * central_angle
}
pub fn distance1(start_lat: f64, start_lon: f64, end_lat: f64, end_lon: f64) -> f64 {
    let kcle_lat_rad = start_lat.to_radians();
    let kslc_lat_rad = end_lat.to_radians();

    let delta_lat = (start_lat - end_lat).to_radians();
    let delta_lon = (start_lon - end_lon).to_radians();

    let inner_circle_angle = f64::powi((delta_lat/2.0).sin(), 2)
        + kcle_lat_rad.cos()
        * kslc_lat_rad.cos()
        * f64::powi(delta_lon/2.0, 2);
    let central_angle = 2.0 * inner_circle_angle.sqrt().asin();

    EARTH_RADIUS_IN_KM * central_angle
}
pub mod calculations {
    // sub module within a module
    const EARTH_RADIUS_IN_KM: f64 = 6371.0;
    pub fn distance(start_lat: f64, start_lon: f64, end_lat: f64, end_lon: f64) -> f64 {
        let kcle_lat_rad = start_lat.to_radians();
        let kslc_lat_rad = end_lat.to_radians();

        let delta_lat = (start_lat - end_lat).to_radians();
        let delta_lon = (start_lon - end_lon).to_radians();

        let inner_circle_angle = f64::powi((delta_lat/2.0).sin(), 2)
            + kcle_lat_rad.cos()
            * kslc_lat_rad.cos()
            * f64::powi(delta_lon/2.0, 2);
        let central_angle = 2.0 * inner_circle_angle.sqrt().asin();

        EARTH_RADIUS_IN_KM * central_angle
    }
}